#!/bin/bash

W=28368
H=19839

for y in `seq 1 $H`; do
	y_=`expr $y - 1`
	echo -n "Row $y... "
	for x in `seq 1 $W`; do
		x_=`expr $x - 1`
		val1=`gdallocationinfo -valonly 1808.tif $x_ $y_`

		sql=" \
SET client_min_messages = ERROR; \
WITH foo AS ( \
	SELECT \
		ST_Raster2WorldCoordX(rast, $x, $y) AS longitude \
		ST_Raster2WorldCoordY(rast, $x, $y) AS latitude \
	FROM test_1808 \
	WHERE rid = 1 \
), \
bar AS ( \
	SELECT \
		ST_SetSRID(ST_MakePoint( \
			longitude, \
			latitude \
		), 4326) AS geom \
	FROM foo \
) \
SELECT \
	ST_Value(rast, geom, false) \
FROM test_1808 t \
CROSS JOIN bar f \
WHERE rast::geometry && geom \
	AND ST_Value(rast, geom, false) IS NOT NULL \
"
		val2=`psql -q -t -U postgres -d test -c "$sql"`

		if [ "0$val2" == "0" ]; then
			echo $x $y $val1 EMPTY
			continue
		fi

		if expr $val1 \!\= $val2 > /dev/null ; then
			echo $x $y $val1 $val2
		fi
	done
	echo "done"
done
