#!/bin/bash

REF="sft00.tif"
PGUSER="postgres"
TABLE="test_1808"
DB="test"

sql="SELECT max(rid) FROM $TABLE"
MAXRID=`psql -q -t -U $PGUSER -d $DB -c "$sql"`

for rid in `seq 1 $MAXRID`; do
	echo -n "$rid "

	sql=" \
SELECT \
	ST_X((pix).geom) AS lon, \
	ST_Y((pix).geom) AS lat, \
	(pix).val \
FROM ( \
	SELECT ST_PixelAsCentroids(rast, 1, FALSE) AS pix FROM $TABLE WHERE rid = $rid \
) foo \
"
	pixset=`psql -q -t -A -U $PGUSER -d $DB -c "$sql"`
	OIFS=$IFS
	IFS="
"

	cnt=0
	for pix in $pixset; do
		lon=`echo $pix | sed 's/|/ /g'| awk '{print $1}'`
		lat=`echo $pix | sed 's/|/ /g'| awk '{print $2}'`
		val1=`echo $pix | sed 's/|/ /g'| awk '{print $3}'`
		val2=`gdallocationinfo -valonly -wgs84 $REF $lon $lat`

		if [ "0$val1" == "0" ]; then
			echo EMPTY $val2
			break
		fi

		if [ "0$val2" == "0" ]; then
			echo $val1 EMPTY
			break
		fi

		if expr $val1 \!\= $val2 > /dev/null ; then
			echo $val1 $val2
			break
		fi

		cnt=`expr $cnt + 1`
		if [ $cnt -eq 10 ]; then
			cnt=0
			echo -n "."
		fi
	done
	IFS=$OIFS

	echo " done"
done
