#!/usr/bin/env python

import sys
import random
import struct
try:
    from osgeo import gdal
    from osgeo import osr
except:
    import gdal
    import osr

def main(argv = None):
	hDataset = gdal.Open("1808.tif", gdal.GA_Update);
	if hDataset is None:
		print("unable to load source file")
		return 1

	hBand = hDataset.GetRasterBand(1)

	for y in range(0, hDataset.RasterYSize):

		tmp = [];
		for x in range(0, hDataset.RasterXSize):
			tmp.append(random.uniform(0, 100))
		data = struct.pack('f' * hDataset.RasterXSize, *tmp)
		tmp = None

		hBand.WriteRaster(
			0, y,
			hDataset.RasterXSize, 1,
			data
		)

	return 0

if __name__ == '__main__':
	version_num = int(gdal.VersionInfo('VERSION_NUM'))
	if version_num < 1800: # because of GetGeoTransform(can_return_null)
		print('ERROR: Python bindings of GDAL 1.8.0 or later required')
		sys.exit(1)

	sys.exit(main(sys.argv))
